 	function DescriptionWindow(id, category, title, questiondesc, qimage) {
 		var self = Ti.UI.createWindow(
	{
		backgroundColor:"#000",
		title: title,
		fullScreen: true,
		modal:true,
		backgroundImage:'/images/background4.jpg'
		
	}
);
 
 var unique_id = id;
 var unique_category = category;
 var unique_title=title;
 var unique_description = questiondesc;
 var unique_image = qimage;
 var mylink = L('mylink');

 		function addFacebookButtons() {
 			
 			 var fb = require('facebook');
			 fb.appid = L('fbappid');
			 fb.permissions = ['publish_stream'];
			 fb.authorize();
		 	 fb.addEventListener('login', function(e) {
				 if (e.success) {
				     alert('Logged in');
				 }
			 });
			 fb.addEventListener('logout', function(e) {
			     alert('Logged out');
			 });
		
			self.add(fb.createLoginButton({
			    top : 50,
			    style : fb.BUTTON_STYLE_WIDE
			}));
			
 		}


function isFavorite(no) {
	var db = Titanium.Database.open(L('contentDB'));
	var dbrows = db.execute('select id from tblfavorite where id = ? ', no);
	while (dbrows.isValidRow()) {
		var idno =dbrows.fieldByName('id');
		
			dbrows.close();
			db.close();
			if (idno === null || idno === undefined)
				return false;
		
			return true;
	}
	dbrows.close();
	db.close();
	return false;
};


function addToFavorite(no) {
	var db = Titanium.Database.open(L('contentDB'));
	db.execute('insert or ignore into tblfavorite select * from tbljokes where id = ? ', no);
		
		//dbrows.close();
		db.close();
}



function removeFromFavorite(no) {
	var db = Titanium.Database.open(L('contentDB'));
	db.execute('delete from tblfavorite where id = ? ', no);
		
		//dbrows.close();
		db.close();
}

function nextChapter(){
	var db = Titanium.Database.open(L('contentDB'));
	var dbrows = db.execute('select id, category, title, description, image from tbljokes where category = ? and id < ? order by id desc limit 1 ', unique_category, unique_id);
	if (dbrows.isValidRow()) {
		var idno =dbrows.fieldByName('id');
		var categoryno = dbrows.fieldByName('category');
		var titleno = dbrows.fieldByName('title');
		var descriptionno = dbrows.fieldByName('description');
		var imageno = dbrows.fieldByName('image');
		
		resetPane(idno, categoryno,titleno,descriptionno,imageno);
	
	}
	dbrows.close();
	db.close();
}

function preChapter(){
	var db = Titanium.Database.open(L('contentDB'));
	var dbrows = db.execute('select id, category, title, description, image from tbljokes where category = ? and id > ? order by id asc limit 1 ',  unique_category, unique_id);
	if (dbrows.isValidRow()) {
		var idno =dbrows.fieldByName('id');
		var categoryno = dbrows.fieldByName('category');
		var titleno = dbrows.fieldByName('title');
		var descriptionno = dbrows.fieldByName('description');
		var imageno = dbrows.fieldByName('image');
		
		resetPane(idno, categoryno,titleno,descriptionno,imageno);
	
	}
	dbrows.close();
	db.close();
}


function resetPane(idno, categoryno,titleno,descriptionno,imageno) {
	view1.removeAllChildren();
	unique_id = idno;
 	unique_category = categoryno;
 	unique_title=titleno;
 	unique_description = descriptionno;
 	unique_image = imageno;
 	
	
	questionDesc.text = unique_description;
 	self.title=unique_title;
 	questionImage.image= unique_image;
	
	
	if (unique_image != null || unique_image != undefined){
		view1.add(questionImage);
	}
	view1.add(questionDesc);
	view1.add(spare);	
	
}

	var data = {
		    link : L('facebook_link') + id,
	    	name : title,
			//message : "This is the message",
			caption : L('facebook_caption'),
			picture : L('facebook_image'),
			description : questiondesc
	};

var verticalBar = Titanium.UI.createView({
	layout: 'vertical',
	width: 75,
	top: 0,
	left:0
});



var fontsizeBtn = Titanium.UI.createButton({
	top: 30,
	width: 48,
	height: 48,
	backgroundImage: '/images/fontsize.png',
});

fontsizeBtn.addEventListener('click', function(e) {
	var currentSize = Ti.App.Properties.getInt('fontSize');
	if (currentSize > 36) {
		currentSize = 18;
	}
	else {
		currentSize = currentSize +4;
	}
	Ti.App.Properties.setInt('fontSize',currentSize);
	questionDesc.font = {fontSize:currentSize};
	
	
});




var favBtn = Titanium.UI.createButton({
	top: 30,
	width: 48,
	height: 48,
	backgroundImage: '/images/silverstar.png',
	backgroundSelectedImage: '/images/goldstar.png'
});

favBtn.addEventListener('click', function(e) {
	if (isFavorite(id)) {
		removeFromFavorite(id);
		favBtn.backgroundImage= '/images/silverstar.png';
		favBtn.backgroundSelectedImage= '/images/goldstar.png';
	}
	else {
		addToFavorite(id);
		favBtn.backgroundImage= '/images/goldstar.png';
		favBtn.backgroundSelectedImage= '/images/silverstar.png';
	}
	
});

	
var btnWhatsapp = Titanium.UI.createButton({
	top:30,
	width: 50,
	height: 53,
	backgroundImage: '/images/whatsapp_small.png'
});


btnWhatsapp.addEventListener('click', function(e) {
	if (questiondesc !== '') {
	
		var intent = Ti.Android.createIntent({
		action: Ti.Android.ACTION_SEND,
		type: "text/plain",
		packageName: "com.whatsapp"
		});
		if (intent !== null) {
			intent.putExtra(Ti.Android.EXTRA_TEXT, questiondesc + "\n\n"+ mylink);
			
			var chooser = Ti.Android.createIntentChooser(intent, "Share with");
			Ti.Android.currentActivity.startActivity(chooser);
		}
	}
	
});

var btnWechat = Titanium.UI.createButton({
	top:30,
	width: 50,
	height: 50,
	backgroundImage: '/images/wechat.png'
});


btnWechat.addEventListener('click', function(e) {
	if (questiondesc !== '') {
	
		var intent = Ti.Android.createIntent({
		action: Ti.Android.ACTION_SEND,
		type: "text/plain",
		packageName: "com.tencent.mm"
		});
		if (intent !== null) {
			intent.putExtra(Ti.Android.EXTRA_TEXT, questiondesc + "\n\n"+ mylink);
			
			var chooser = Ti.Android.createIntentChooser(intent, "Share with");
			Ti.Android.currentActivity.startActivity(chooser);
		}
	}
});


var btnFacebook = Titanium.UI.createButton({
	top:30,
	width: 50,
	height: 50,
	backgroundImage: '/images/facebook_small.png'
});


btnFacebook.addEventListener('click', function(e) {
	if (questiondesc !== '') {
	
	var data = {
		    link : L('facebook_link'),
	    	name : title,
			//message : "This is the message",
			//caption : L('facebook_caption'),
			caption: title,
			//picture : L('facebook_image'),
			description : questiondesc 
	};
	
	 var fb = require('facebook');
	 //fb.appid = '191772614341506';
	 fb.appid = L('fbappid');
	 fb.permissions = ['publish_stream'];	 
			//log in and accept permissions
			//fb.permissions = ['email'];
			//fb.authorize();
			//share dialog
				//fb.dialog("feed", data, function(e) {
			fb.dialog("feed", data, function(e) {
				if(e.success && e.result) {
				    alert(L('facebook_po_msg') + e.result);
				} else {
				    if(e.error) {
				        alert(e.error);
				    } else {
				        alert(L('facebook_user_cancel'));
				    }
			    }
			});
	}
});


	if (isFavorite(id)) {
		favBtn.backgroundImage='/images/goldstar.png';
		favBtn.backgroundSelectedImage='/images/silverstar.png';
	}
	else { 
		favBtn.backgroundImage='/images/silverstar.png';
		favBtn.backgroundSelectedImage='/images/goldstar.png';
	}
	
verticalBar.add(fontsizeBtn);
verticalBar.add(favBtn);
verticalBar.add(btnWhatsapp);
verticalBar.add(btnWechat);
verticalBar.add(btnFacebook);
 		
 		//var screenHeight = Titanium.Platform.displayCaps.platformHeight -50;
 		//Titanium.UI.createAlertDialog({title:'genScroll',message:e.rowData.qtitle}).show();
 		var view1 = Ti.UI.createScrollView({
			left:75,
			layout: 'vertical',
			//height: screenHeight,
			top:0,
			contentHeight:'auto'
		});
		
			var questionImage = Titanium.UI.createImageView({
				image:qimage,
				top:30,
				left:10,
				right: 10,
				width: Titanium.Platform.displayCaps.platformWidth-75,
				height: 'auto',
				enableZoomControls: false
			});
			
			var currentSize = Ti.App.Properties.getInt('fontSize');
			//var topY = questionImage.getHeight() + 20;
	/*		var providerLabel = Titanium.UI.createLabel({
				text: 'Provided by: ' + provider,
				top:10,
				color: '#000',
				height: 'auto',
				width: 'auto',
				right: 10,
				font:{fontSize:12},
				textAlign:'right',
			});
		*/	
			var questionDesc = Titanium.UI.createLabel({
				text:questiondesc,
				top:40,
				color: '#000',
				height: 'auto',
				width: 'auto',
				left: 10,
				font:{fontSize:currentSize},
				textAlign:'left',
				right: 10			
			});
			
			var spare = Titanium.UI.createLabel({
				top:0,
				color: '#000',
				height: '55',
				width: 'auto',
			});
			
	/*		
			if(provider != null || provider != undefined)
				view1.add(providerLabel);
		*/				
			if (qimage != null || qimage != undefined){
				view1.add(questionImage);
			}
			
			view1.add(questionDesc);
			

			
			
			//view1.add(buttomView);
			view1.add(spare);
			
			var Admob = require('ti.admob');
			var mySmart =  L('admob_smart');
	
			var adv = Admob.createView({
				bottom: 0,
				adSizeType: 'SMART',
				publisherId: mySmart ,
				testing: false
			});
			//adv.animate(animation);

self.addEventListener('swipe', function(e) {
	Ti.API.info("swipe direction:" + e.direction);
   if (e.direction == 'left') {
      nextChapter();
   } else if (e.direction == 'right') {
      preChapter();
   }
});
			
			self.add(verticalBar);
			self.add(view1);
			self.add(adv);
			return self;
					
 	}
 	module.exports = DescriptionWindow;