var categoryHeader = [];

var self = Titanium.UI.currentWindow;
self.backgroundImage="/images/bookcover2.jpg";
var view = Titanium.UI.createScrollView({
	layout: 'horizontal',
	//backgroundColor: '#999999',
	top:50
});


var lang = L('language');
var busy = false;
var height=50;
var width=320;
var queryIndex=0;
// populate category array from database
// only called on first rendering of the tab, after that the array is filled
/*
	var MillennialMedia = require('ti.millennialmedia');
	MillennialMedia.apid = '150546';
	MillennialMedia.demographics = {
	    age: '25',
	    //gender: 'male',
	    //zip: '60187',
	    //lat: '41.866', 'long': '-88.107'
	};

    var view = MillennialMedia.createView({
        apid: '150908',
        // It can be desirable to set the size of the view to 0 for interstitial ads to 
        // ensure that it does not block the UI while it is loading, before it is displayed. 
        top: 0, width: 0, height: 0,
        adType: MillennialMedia.TYPE_INTERSTITIAL
    });
    
    MillennialMedia.addEventListener('adRequestComplete', requestComplete);
    function requestComplete(e) {
        Ti.API.info('interstitial adRequestComplete');
        MillennialMedia.removeEventListener('adRequestComplete', requestComplete);
        if (!e.success) {
            self.remove(view);
        }
    }
    
    MillennialMedia.addEventListener('modalDidDismiss', modalDidDismiss);
    function modalDidDismiss() {
        Ti.API.info('interstitial modalDidDismiss');
        MillennialMedia.removeEventListener('modalDidDismiss', modalDidDismiss);
        self.remove(view);
       
          //  Ti.UI.iPhone.setStatusBarHidden(false);
       
    }
  */ 
   			var Admob = require('ti.admob');
			var myInterstitial =  L('admob_interstitial');
			var mySmart =  L('admob_smart');
			var view = Admob.createView({
				adSizeType: 'INTERSTITIALAD',
				publisherId: myInterstitial ,
				testing: false
			});				
   
   self.add(view);



//var advertise = bottomAdView();

var advertise = Admob.createView({
					bottom: 0,
					adSizeType: 'SMART',
					publisherId: mySmart ,
					testing: false
			});
 


var mainScrollView = Titanium.UI.createScrollView({
	//backgroundColor: '#ffffff',
	top:0,
	bottom:height
});

var secondWindow = Titanium.UI.createWindow({
	backgroundColor: '#ffffff',
	fullScreen: true,
	modal:true,
	buttom:50,
	backgroundImage: '/images/background4.jpg'
});
var secondView = Titanium.UI.createView({
	layout: 'vertical'
});
secondWindow.add(secondView);


var adv = Admob.createView({
					top: 0,
					adSizeType: 'SMART',
					publisherId: mySmart ,
					testing: false
			});

			//adv.animate(animation);
			


//	adv.animate(animation);
	//return ads;
	
			
			secondView.add(adv);

var categoryTableView = Titanium.UI.createTableView({
	data:[],
	top:0, 
	separatorColor: '#000'
});

secondView.add(categoryTableView);

//composeHeader();
composeVerticalHeader();


// category view event listener
categoryTableView.addEventListener('click', handleCategoryClick);
view.add(categoryTableView);
//categoryTableView.fireEvent('click', {vid: 1});

// add category table view to the window
Titanium.UI.currentWindow.add(mainScrollView);
Titanium.UI.currentWindow.add(advertise);


function composeVerticalHeader(){
	
	if (categoryHeader.length == 0) {
		var db = Titanium.Database.open(L('contentDB'));
		var dbrows = db.execute('select id, name from tblcategory where lang = ?', lang);
		while (dbrows.isValidRow()) {
		    categoryHeader.push({
		    	catid:dbrows.fieldByName('id'),
		    	title:dbrows.fieldByName('name')
		    }); 
		    //Ti.API.info("Found category: "+dbrows.fieldByName('title')+" ["+dbrows.fieldByName('id')+"]");
		    dbrows.next();
		}
		dbrows.close();
		db.close();
	}
	
	
	var middle = Titanium.Platform.displayCaps.platformWidth/2 - 40;
	var portion = parseInt(Titanium.Platform.displayCaps.platformWidth/3);
	var x = middle/2 -40;
	var y = middle/2 -40;
	
	//loadingOn();
	for (var i=0; i<categoryHeader.length; i++) {
		var categoryButton = Titanium.UI.createButton({
			top: y,
			left: x,
			width: 80,
			height:80,
			title: categoryHeader[i].title,
			id: categoryHeader[i].catid,
			backgroundImage: '/images/orange.png'
			//font: {fontSize: 20}
		});
		
		categoryButton.addEventListener('click', function(e) {
			//open new category window
			queryIndex=0;
			generateTableRowFromDB(e.source.id, queryIndex);
			
						
			
			var buttomView = Titanium.UI.createView({
				bottom: 0,
				height: 50
			});
			
			var leftBtn = Titanium.UI.createButton({
				height: 50,
				width:50,
				left:10,
				backgroundImage: '/images/left.png',
				title: L('pre'),
				color: '#ffffff'
			});
			
			var rightBtn = Titanium.UI.createButton({
				height: 50,
				width:50,
				right:10,
				backgroundImage: '/images/right.png',
				title: L('next'),
				color: '#ffffff'
			});
			
			leftBtn.addEventListener('click', function(ev) {
				generateTableRowFromDB(e.source.id, --queryIndex);
			});
			
			rightBtn.addEventListener('click', function(ev) {
				generateTableRowFromDB(e.source.id, ++queryIndex);
			});
				
			buttomView.add(leftBtn);
			buttomView.add(rightBtn);
			secondWindow.add(buttomView);
			secondView.add(categoryTableView);

			
			//secondWindow.add(categoryTableView);
			secondWindow.open();
		});
	
		var xInd = (i % 3);
		switch(xInd) {
			case 2:
				x= (middle/2)-40;
				y = y+ 130;
				break;
			case 0:
				x= middle;
				break;
			case 1:
				x= (middle*1.5)+40 ;
				break;
		}		

		mainScrollView.add(categoryButton);	
		//loadingOff();	
	}
	
	// add favorite icon
	var favBtn = Titanium.UI.createButton({
			top: y,
			left: x,
			width: 80,
			height:80,
			title: L('favorite'),
		backgroundImage: '/images/heart.png'
	});
	favBtn.addEventListener('click', function(e) {
		// add favorite window
		generateTableRowFromFavoriteDB();
		secondWindow.open();
	});
		
	mainScrollView.add(favBtn);
	
};


function getRowCount(category) {
		var db = Titanium.Database.open(L('contentDB'));
		var dbrows = db.execute('select count(1) as count from tbljokes where category = ? ',category);
		
		var count =dbrows.fieldByName('count');
	
		dbrows.close();
		db.close();
		if (max == null)
			return 0;
			
		return count; 
};

function generateTableRowFromDB(vid, query) {
	var rowItem = [];
				//queryIndex=0;
				var db = Titanium.Database.open(L('contentDB'));
				var dbrows = db.execute('select id, title, category, description, image from tbljokes where category = ? order by id desc limit 20 offset '+(query * 20), vid);
				var c=0;
				//loadingOn();
				while (dbrows.isValidRow()) {
						var title = dbrows.fieldByName('title');
						var id = dbrows.fieldByName('id');
						var category = dbrows.fieldByName('category');
						var desc = dbrows.fieldByName('description');
						var image = dbrows.fieldByName('image');
					    var row = Ti.UI.createTableViewRow({
					    	height:'auto',
					    	//backgroundColor:'#ffffff',
					    	backgroundSelectedColor:'#eeee33',
					    	catid: id,
				    		joketitle: title,
				    		category: category,
				    		desc: desc,
				    		image: image,
				    		hasChild: true
			    		}); 
					    
			    		var titleLable = Ti.UI.createLabel({
							text: title,
							color: '#000000',
							textAlign:'left',
							left:30,
							top:10,
							buttom:10,
							height:'auto',
							font: {fontSize:Ti.App.Properties.getInt('fontSize')}
							//font:{fontWeight:'bold',fontSize:20}
						});
			    		
			    		row.add(titleLable);
			    		rowItem[c] = row;
			    		lastIndex = id;
			    		
			    		dbrows.next();
			    		c++;
					}
				
				dbrows.close();
				db.close();
				
				var row = Ti.UI.createTableViewRow({
					    	height:50,
			    		});
			    rowItem[c] = row; 
				categoryTableView.setData(rowItem);
				//loadingOff();
	
};



function generateTableRowFromFavoriteDB() {
	var rowItem = [];
				var db = Titanium.Database.open(L('contentDB'));
				var dbrows = db.execute('select id, title, category, description, image from tblfavorite');
				var c=0, i=0;
				//loadingOn();
				while (dbrows.isValidRow()) {
						var title = dbrows.fieldByName('title');
						var id = dbrows.fieldByName('id');
						var category = dbrows.fieldByName('category');
						var desc = dbrows.fieldByName('description');
						var image = dbrows.fieldByName('image');
					    var row = Ti.UI.createTableViewRow({
					    	height:'auto',
					    	//backgroundColor:'#ffffff',
					    	backgroundSelectedColor:'#eeee33',
					    	catid: id,
				    		joketitle: title,
				    		category: category,
				    		desc: desc,
				    		image: image
			    		}); 
					    
			    		var titleLable = Ti.UI.createLabel({
							text: title,
							color: '#000000',
							textAlign:'left',
							left:30,
							top:10,
							buttom:10,
							height:'auto',
							font:{fontSize:Ti.App.Properties.getInt('fontSize')}
						});
			    		
			    		row.add(titleLable);
			    		rowItem[c] = row;
			    		lastIndex = id;
			    	
			    		dbrows.next();
			    		c++;
					}
				
				dbrows.close();
				db.close();
			    var row = Ti.UI.createTableViewRow({
					    	height:50,
			    		});
			    rowItem[c] = row; 
				categoryTableView.setData(rowItem);
	//loadingOff();

};


function composeTableRowByCategoryId(vid) {
			if (vid === undefined || vid === null) {
				vid = 1;
			}
				setBackgroundColorForHeader(vid);
				var rowItem = [];
				generateInitialContent(vid) ;
				busy = false;  
};


function showItemsInCategory(cid, category,title, desc, image) {
		var itemArray = [];
		Ti.API.info("-> "+title+" <- clicked");
		
		// populate item array from database
		// called every time a category row is clicked
		//var db = Titanium.Database.open(L('contentDB'));
		//var dbrows = db.execute('select id, title, description, image from tbljokes where id= ? ',cid);
		//if (dbrows.isValidRow()) {
			DescriptionWindow = require("DescriptionWindow");
			var descWin = DescriptionWindow(cid, category, title, desc,image);
			//Titanium.UI.currentWindow.containingTab.open(descWin);
			descWin.open({    
			    activityEnterAnimation: Ti.Android.R.anim.slide_in_right,
    			activityExitAnimation: Ti.Android.R.anim.slide_out_left			
			});
			
 
};


// called when use clicks on a category to see items in that category
function handleCategoryClick(e) {	
		if(e.row.catid === undefined || e.row.catid === null) {
			return;
		}		
	//Titanium.UI.createAlertDialog({title:e.row.catid,message:e.row.catname}).show();	
	//if (e.row.catid == -1) {
		//busy = true;
		//showModalWindow();
	//	loadingOn();
		//Titanium.UI.createAlertDialog({title:'bingo',message:e.row.category}).show();
		//getFromRemote(remoteURL2, e.row.category, getMaxId, updateCategoryViewAtFirst);
		//getFromRemote(remoteURL, e.row.category, getFirstId, updateCategoryViewAtLast);
	//	appendContentFromRemote(remoteURL, e.row.category);
		//setTimeout(checkBusy, 300);
	//	loadingOff();
	//}
	//else 
		showItemsInCategory(e.row.catid, e.row.category,e.row.joketitle, e.row.desc, e.row.image);
};


function getLastId(table) {
		var db = Titanium.Database.open(L('contentDB'));
		var dbrows = db.execute('select max(id) as max from ' + table);
		
		var max =dbrows.fieldByName('max');
	
		dbrows.close();
		db.close();
		
		return max; 
};

function getMaxId(category) {
		var db = Titanium.Database.open(L('contentDB'));
		var dbrows = db.execute('select max(id) as max from tbljokes where category = ? ',category);
		
		var max =dbrows.fieldByName('max');
	
		dbrows.close();
		db.close();
		if (max == null)
			return 999999;
			
		return max; 
};

function addToFavorite(no) {
	var db = Titanium.Database.open(L('contentDB'));
	db.execute('insert or ignore into tblfavorite select * from tbljokes where id = ? ', no);
		
		//dbrows.close();
		db.close();
};


function removeFromFavorite(no) {
	var db = Titanium.Database.open(L('contentDB'));
	db.execute('delete from tblfavorite where id = ? ', no);
		
		//dbrows.close();
		db.close();
};

function getFirstId(category) {
		var db = Titanium.Database.open(L('contentDB'));
		var dbrows = db.execute('select min(id) as min from tbljokes where category = ? ',category);
		
		var min =dbrows.fieldByName('min');
	
		dbrows.close();
		db.close();
		if (min == null)
			return 999999;
			
		return min; 
};

// When updating, this function is on a scheduled timer, and will 
// only stop firing once the update is complete.
