// Initialize database
Titanium.Database.install(L('db_file'),L('contentDB'));
var db = Titanium.Database.open(L('contentDB'));
//var conn = Titanium.Database.install('content.db','jokesdb');
db.execute('CREATE TABLE IF NOT EXISTS tbljokes (id INTEGER PRIMARY KEY, category integer, title text, description text, image varchar(200))');
db.execute('CREATE TABLE IF NOT EXISTS tblcategory (id INTEGER PRIMARY KEY, name text, lang varchar(3))');
db.close();
// Restore long term application settings
var currentSize = Ti.App.Properties.getInt('fontSize');
if (currentSize == null || currentSize < 18 || currentSize > 36) {
	currentSize = 18;
	Ti.App.Properties.setInt('fontSize',18);
}
// this sets the background color of the master UIView
Titanium.UI.setBackgroundColor('#000');

// create tab group
var tabGroup = Titanium.UI.createTabGroup({
	exitOnClose: true
});

// Tab for main screen
var win0 = Titanium.UI.createWindow({
    url:'/ui/common/tab_jokes.js',
    title:L('Jokes')
});
win0.barColor = '#993333';
var tab0 = Titanium.UI.createTab({
    icon:'/images/happy2.png',
    title:L('Jokes'),
    window:win0
});


// Tab for tricks
var win2 = Titanium.UI.createWindow({  
    url:'/ui/common/tab_tricks.js',
    title:L('Tricks')
});
win2.barColor = '#993333';
var tab2 = Titanium.UI.createTab({  
    icon:'/images/question2.png',
    title:L('Tricks'),
    window:win2
});


// Tab for tricks
var win3 = Titanium.UI.createWindow({  
    url:'/ui/common/upload.js',
    title:L('Report_us')
});
win3.barColor = '#993333';
var tab3 = Titanium.UI.createTab({  
    icon:'/images/comment2.png',
    title:L('Report_us'),
    window:win3
});



win0.containingTab = tab0;
win2.containingTab = tab2;
win3.containingTab = tab3;
// Add tabs to tabgroup 
tabGroup.addTab(tab0);
tabGroup.addTab(tab2);  
tabGroup.addTab(tab3);
// Open tab group
tabGroup.open();
