  var window = Titanium.UI.currentWindow;({
    backgroundColor: '#000000'
  });
  
  var win = Ti.UI.createView({
  	top: 0,
   	backgroundColor: '#000000',
  	layout: 'vertical'
  });
  var txtTitle = Ti.UI.createTextField({ 
  	    backgroundColor:'#ffffff',
  		top: 10, 
  		left: 20,
  		font: {fontSize:18},
  		width: 150,
  		color:'#000',
	  	hintText: L('hint_your_name'),
	  	borderWidth: 2,
	  	borderColor: '#bbb',
	 	borderRadius: 5
  		 });
  win.add(txtTitle);
  
  var textArea = Ti.UI.createTextArea({
  	  backgroundColor: '#ffffff',
	  borderWidth: 2,
	  borderColor: '#bbb',
	  borderRadius: 5,
	  color:'#000',
	  //color: '#888',
	  font: {fontSize:18},
	  //keyboardType: Ti.UI.KEYBOARD_NUMBER_PAD,
	  //returnKeyType: Ti.UI.RETURNKEY_GO,
	  //textAlign: 'left',
	  top: 7,
	  left: 20, 
	  height : '33%',
	  right: 20,
	  hintText: L('hint_description')
	});
	win.add(textArea);
  
  var container = Ti.UI.createView({
  	top: 7,
  	left: 20,
  	width: 150,
  	height: 150,
  	borderWidth: 2,
  	borderColor: '#bbb',
  	backgroundColor: '#ffffff',
  	borderRadius: 5
  });
  
  var imageView = Ti.UI.createImageView({
  	  width: 148,
  	  height: 148
  	  //image: 'camera.png'
  });
  
  var imageView2 = Ti.UI.createImageView({
  	  height: 64,
  	  width: 64,
  	  image: '/images/camera.png'
  });

  container.add(imageView2);
  win.add(container);
  
  container.addEventListener('click', function(e) {
  	  Ti.Media.openPhotoGallery({
      mediaTypes:[Ti.Media.MEDIA_TYPE_PHOTO],
      success:function(e) {
        imageView.image = e.media;
       	container.add(imageView);
      },
      cancel:function() {
      },
      error:function(err) {
        Ti.API.error(err);
      }
    });
    f = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory,'camera_photo.png');
    f.write(e.media);
  });
 
  var btnSubmit = Ti.UI.createButton({ 
  	title: L('submit'),
  	height: 40,
  	width: Titanium.Platform.displayCaps.platformWidth /2
   });

  var ind=Titanium.UI.createProgressBar({
      width:(Titanium.Platform.displayCaps.platformWidth - 60),
      left:30,
      height:30,
      min:0,
      max:1,
      value:0,
      style:Titanium.UI.iPhone.ProgressBarStyle.PLAIN,
      buttom:0,
      //message:'Uploading Image',
      font:{fontSize:12, fontWeight:'bold'},
      color:'#888'
});
 
win.add(ind);
ind.show();
 

  btnSubmit.addEventListener('click', function(e) {
 	
  if ( txtTitle.value == null || txtTitle.value == '' ) {
  	Titanium.UI.createAlertDialog({title:L('insufficient_info'),message: L('hint_your_name')}).show();
  	return;
  }
  if (textArea.value == null || textArea.value == '') {
  	Titanium.UI.createAlertDialog({title:L('insufficient_info'),message: L('hint_description')}).show();
  	return;
  }

  
  
    //Ti.API.info("success! event: " + JSON.stringify(event));
    var image = imageView.image;
    var xhr = Titanium.Network.createHTTPClient();
    xhr.onerror = function(e)
    {
        Ti.API.info('IN ERROR ' + e.error);
    };
    xhr.onload = function()
    {
        Ti.API.info('IN ONLOAD ' + this.status + ' readyState ' + this.readyState);
        Ti.API.info(this.responseText);
        Titanium.UI.createAlertDialog({title:L('thank_title'),message: L('thank_message')}).show();
        resetAll();
    };
    xhr.onsendstream = function(e)
    {
        ind.value = e.progress ;
        Ti.API.info('ONSENDSTREAM - PROGRESS: ' + e.progress+' '+this.status+' '+this.readyState);
    };
    // open the client
    xhr.open('POST',L('upload_url'));
    xhr.setRequestHeader("Connection", "close");
    // send the data
    xhr.send({file:image,
    		title: txtTitle.value,
    		desc: textArea.value});
 
  });

  var scrollView = Ti.UI.createScrollView({
	layout: 'horizontal',
  	bottom:0,
  	height: 40,
  	backgroundColor: '#000000'
  });

  var btnClear = Ti.UI.createButton({
  	title: L('clear'),
  	height: 40,
  	width: Titanium.Platform.displayCaps.platformWidth /2
  }); 
  
  btnClear.addEventListener('click', function(e) {
  	resetAll();
  });
  
  function resetAll(){
  	txtTitle.value = '';
  	textArea.value = '';
  	container.remove(imageView);
  	ind.value = 0;
  	ind.message = '';
  	imageView.image= null;
  };
  
  
  
  scrollView.add(btnClear);
  scrollView.add(btnSubmit);

  window.add(win);
  window.add(scrollView);

